# Proto role labeling (SPRL) with argument-predicate marker embedding

Span based SPRL approach. Given a sentence, a predicate and an argument, the model learns to highlight predicate and argument seperately and predicts up to 18 proto role properties (multi-label or Likert). A simple voter ensemble further improves results.

### Prerequisites

see environment.yml

## Reproducing the multi-labeling results with Bert embeddings

```
cd src
./run_ensemble.sh
```

when ready

```
python check_test_scores.py
```

results may slighlty vary from run to run (because of small data, random model inits)

### Running Likert only regression or manipulating/improving the model


General hyperparameters can be set in 

```
src/config.py
```

The model can be modified in:

```
src/model.py
```

The training cycle can be improved in:

```
src/proto_model_bert.py
```

The data setup and preprocessing can be modified in

```
src/data_setup.py
```

E.g., for now we average the results of two random annotators in SPR2 data. We could determine trusty annotators and weigh their opinions more. This should improve SPRL for web-texts (i.e. SPR2 data).


## Citation

```

@inproceedings{opitzfrank:2019b,
  author = {Juri Opitz and Anette Frank},
  title = {{An Argument-Marker Model for Syntax-Agnostic Proto-Role Labeling}},
  year = {2019},
  publisher = {Association for Computational Linguistics},
  booktitle = {Proceedings of The Eighth Joint Conference on Lexical and Computational Semantics (*SEM 2019)},
  note = {to appear}
}

```

## SPR data

when using SPR data do not forget to cite the creators. see the readme in src/resources

# contact 

Me: opitz@cl.uni-heidelberg.de




